"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, "next"); var callThrow = step.bind(null, "throw"); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _crankshaft = require("crankshaft");

var _crankshaft2 = _interopRequireDefault(_crankshaft);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _utilsFs = require("../../../utils/fs");

var _utilsFs2 = _interopRequireDefault(_utilsFs);

var _utilsConfig = require("../../../utils/config");

var _utilsConfig2 = _interopRequireDefault(_utilsConfig);

/*
    Parameters:
    ----------
    tasks = [
        {
            name: "transpile-custom-builds-and-plugins",
            plugin: builtInPlugins.babel,
            options: {
               source: buildRoot,
               destination: path.resolve(siteConfig.destination, dir),
               extensions: siteConfig["js-extensions"],
               blacklist: ["regenerator"]
           }
       }
   ];
   dir: root director for the build
   onComplete: Callback when the build completes
   monitor: bool, keep monitoring the files?
*/
var runTasks = _asyncToGenerator(function* (tasks, dir, onComplete, monitor) {
    var build = _crankshaft2["default"].create();

    build.configure(function () {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
            for (var _iterator = tasks[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var task = _step.value;

                var runnable = task.plugin ? task.plugin(task.name, task.options || {}) : task;
                runnable.call(this);
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion && _iterator["return"]) {
                    _iterator["return"]();
                }
            } finally {
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }, dir);

    if (onComplete) {
        build.onComplete(onComplete);
    }

    yield build.start(monitor);
});

/*
    Load customTasks from the config.dir_custom_tasks directory.
*/
var getCustomTasks = _asyncToGenerator(function* (siteConfig, builtInPlugins) {
    var tasksFile = _path2["default"].resolve(siteConfig.destination, siteConfig["custom-tasks-dir"], siteConfig.build + ".js");

    if (yield _utilsFs2["default"].exists(tasksFile)) {
        return require(taskPath)(siteConfig, builtInPlugins);
    }
});

exports["default"] = { runTasks: runTasks, getCustomTasks: getCustomTasks };
module.exports = exports["default"];