"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, "next"); var callThrow = step.bind(null, "throw"); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _utilsFs = require("../../../utils/fs");

var _utilsFs2 = _interopRequireDefault(_utilsFs);

var _utilsConfig = require("../../../utils/config");

var _utilsConfig2 = _interopRequireDefault(_utilsConfig);

var _utilsLogging = require("../../../utils/logging");

var _buildUtilsCommonTasks = require("../build-utils/common-tasks");

var _buildUtilsCommonTasks2 = _interopRequireDefault(_buildUtilsCommonTasks);

var _buildUtilsStandardBuild = require("../build-utils/standard-build");

var _buildUtilsStandardBuild2 = _interopRequireDefault(_buildUtilsStandardBuild);

var _optimist = require("optimist");

var _optimist2 = _interopRequireDefault(_optimist);

var _ceramicBackendMongodb = require("ceramic-backend-mongodb");

var _ceramicBackendMongodb2 = _interopRequireDefault(_ceramicBackendMongodb);

var argv = _optimist2["default"].argv;
var data = {};

var build = (0, _buildUtilsStandardBuild2["default"])("database", _asyncToGenerator(function* (siteConfig, builtInPlugins) {

    if (process.env.NODE_ENV === "production") {
        throw new Error("This build cannot be run when NODE_ENV is set to production.");
    }

    var _getCommonTasks = (0, _buildUtilsCommonTasks2["default"])("database", siteConfig, builtInPlugins);

    var getLoadDataTask = _getCommonTasks.getLoadDataTask;

    var tasks = [getLoadDataTask({
        name: "load-data",
        data: data
    })];

    return tasks;
}), _asyncToGenerator(function* (siteConfig) {
    var logger = (0, _utilsLogging.getLogger)(siteConfig.quiet, "database");
    var db = argv.db;

    if (db) {
        var mongoDb = yield _ceramicBackendMongodb2["default"].MongoClient.connect({ database: db });
        for (var coll in data) {
            var mongoCollection = yield mongoDb.collection(coll);
            if (data[coll].length) {
                logger("Inserting " + data[coll].length + " records into " + coll + ".");
                yield mongoCollection.insertMany(data[coll]);
            } else {
                logger(coll + " has zero records. skipping.");
            }
        }
        yield mongoDb.close();
    } else {
        throw new Error("Specify the name of the db with the --db parameter.");
    }
}));

exports["default"] = build;
module.exports = exports["default"];