"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, "next"); var callThrow = step.bind(null, "throw"); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _utilsFs = require("../../../utils/fs");

var _utilsFs2 = _interopRequireDefault(_utilsFs);

var _utilsConfig = require("../../../utils/config");

var _utilsConfig2 = _interopRequireDefault(_utilsConfig);

var _utilsLogging = require("../../../utils/logging");

var _buildUtilsCommonTasks = require("../build-utils/common-tasks");

var _buildUtilsCommonTasks2 = _interopRequireDefault(_buildUtilsCommonTasks);

var _buildUtilsStandardBuild = require("../build-utils/standard-build");

var _buildUtilsStandardBuild2 = _interopRequireDefault(_buildUtilsStandardBuild);

var build = (0, _buildUtilsStandardBuild2["default"])("production", _asyncToGenerator(function* (siteConfig, builtInPlugins) {
    var _getCommonTasks = (0, _buildUtilsCommonTasks2["default"])("production", siteConfig, builtInPlugins);

    var getTranspileServerTask = _getCommonTasks.getTranspileServerTask;
    var getLessTask = _getCommonTasks.getLessTask;
    var getCopyStaticFilesTask = _getCommonTasks.getCopyStaticFilesTask;
    var getWriteConfigTask = _getCommonTasks.getWriteConfigTask;
    var getBuildClientTask = _getCommonTasks.getBuildClientTask;

    var buildConfigReader = _utilsConfig2["default"].getReader(siteConfig, ["builds", "production"]);
    var browserBuildFileSuffix = buildConfigReader(["browser-build-file-suffix"], "~client");
    var browserReplacedFileSuffix = buildConfigReader(["browser-replaced-file-suffix"], "_base");

    var tasks = [getTranspileServerTask({
        name: "transpile-server"
    }), getLessTask({
        name: "less"
    }), getCopyStaticFilesTask({
        name: "copy-static-files",
        destination: siteConfig.destination
    }), getWriteConfigTask({
        name: "write-config",
        destination: siteConfig.destination
    }), getWriteConfigTask({
        name: "write-client-config",
        destination: buildConfigReader(["client-build-dir"], "js")
    }), getBuildClientTask({
        name: "build-browser-app",
        browserBuildFileSuffix: browserBuildFileSuffix,
        browserReplacedFileSuffix: browserReplacedFileSuffix,
        debug: false
    })];

    return tasks;
}));

exports["default"] = build;
module.exports = exports["default"];