"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, "next"); var callThrow = step.bind(null, "throw"); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _frontMatter = require("front-matter");

var _frontMatter2 = _interopRequireDefault(_frontMatter);

var _nodeMarkdown = require("node-markdown");

var _nodeMarkdown2 = _interopRequireDefault(_nodeMarkdown);

var _utilsFs = require("../../../../utils/fs");

var _utilsFs2 = _interopRequireDefault(_utilsFs);

var _pretty = require("pretty");

var _pretty2 = _interopRequireDefault(_pretty);

var _utilsLogging = require("../../../../utils/logging");

var md = _nodeMarkdown2["default"].Markdown;

exports["default"] = _asyncToGenerator(function* (page, sourcePath, layout, makePath, siteConfig) {
    var logger = (0, _utilsLogging.getLogger)(siteConfig.quiet, "jekyll html generator");
    var jekyllConfig = siteConfig.jekyll;

    try {
        var layoutsourcePath = undefined,
            params = undefined,
            component = undefined;

        //Source path and layout are the same only when generating plain JSX templates (without frontmatter)
        if (sourcePath !== layout) {
            layoutsourcePath = _path2["default"].resolve(siteConfig.destination, jekyllConfig.dirs_layouts + "/" + (page.layout || layout));
            params = { page: page, content: page.content, site: siteConfig };
        } else {
            page = {};
            layoutsourcePath = _path2["default"].resolve(siteConfig.destination, layout);
            params = { page: page, content: "", site: siteConfig };
        }
        component = _react2["default"].createFactory(require(layoutsourcePath))(params);
        var reactHtml = _react2["default"].renderToString(component);
        var html = "<!DOCTYPE html>" + siteConfig.beautify ? (0, _pretty2["default"])(reactHtml) : reactHtml;

        var outputPath = _path2["default"].resolve(siteConfig.destination, makePath(sourcePath, page));

        var outputDir = _path2["default"].dirname(outputPath);
        if (!(yield _utilsFs2["default"].exists(outputDir))) {
            yield _utilsFs2["default"].mkdirp(outputDir);
        }

        logger(sourcePath + " -> " + outputPath);

        yield _utilsFs2["default"].writeFile(outputPath, html);

        return { page: page };
    } catch (err) {
        logger("cannot process " + sourcePath + " with template " + layout + ".");
        throw err;
    }
});
module.exports = exports["default"];