"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, "next"); var callThrow = step.bind(null, "throw"); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _doLayout = require("./do-layout");

var _doLayout2 = _interopRequireDefault(_doLayout);

var _utilsFs = require("../../../../utils/fs");

var _utilsFs2 = _interopRequireDefault(_utilsFs);

exports["default"] = function (siteConfig) {

    var jekyllConfig = siteConfig.jekyll;

    var makePath = function makePath(filePath, page) {
        var permalink = siteConfig.permalink;

        var dir = _path2["default"].dirname(filePath);
        var extension = _path2["default"].extname(filePath);
        var basename = _path2["default"].basename(filePath, extension);

        return _path2["default"].join(dir, basename + ".html");
    };

    /*
        Templates are JSX files outside the _layouts directory
    */
    var fn = function fn() {
        var extensions = [_path2["default"].resolve(siteConfig.destination) + "/*.js"];

        var excluded = ["!app.bundle.js"].concat(siteConfig.dirs_exclude.concat(siteConfig.dirs_client_vendor).concat(siteConfig.dir_client_build).concat(siteConfig.dir_dev_build).concat(siteConfig.dir_custom_tasks).concat(jekyllConfig.dirs_includes).concat(jekyllConfig.dirs_layouts).concat(jekyllConfig.dir_fora).map(function (dir) {
            return "!" + dir + "/";
        }).concat(siteConfig.patterns_exclude));

        this.watch(extensions.concat(excluded), _asyncToGenerator(function* (filePath, ev, matches) {
            var result = yield (0, _doLayout2["default"])(null, filePath, filePath, makePath, siteConfig);
        }), "build_templates");
    };

    return { build: true, fn: fn };
};

module.exports = exports["default"];