"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, "next"); var callThrow = step.bind(null, "throw"); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _utilsFs = require("../../../utils/fs");

var _utilsFs2 = _interopRequireDefault(_utilsFs);

var _utilsLogging = require("../../../utils/logging");

var _optimist = require("optimist");

var _optimist2 = _interopRequireDefault(_optimist);

var argv = _optimist2["default"].argv;
/*
    options: {
        destination: string,
        extensions: [string],
        excludedFiles: [string],
        excludedDirectories: [string],
        excludedPatterns: [regex or string],
        excludedExtensions: [string],
        excludedWatchPatterns = [regex],
        changeExtensions: [ { to: "js", from: ["es6", "jsx"]}]
        quiet: bool
    }
*/
var copyStaticFiles = function copyStaticFiles(name, options) {
    var verboseMode = argv["verbose-" + name];
    var logger = (0, _utilsLogging.getLogger)(options.quiet, name || "copy-static-files");

    //defaults
    options.extensions = options.extensions || ["*.*"];
    options.excludedFiles = options.excludedFiles || [];
    options.excludedDirectories = (options.excludedDirectories || []).concat(options.destination);
    options.excludedPatterns = options.excludedPatterns || [];
    options.excludedExtensions = options.excludedExtensions || [];
    options.excludedWatchPatterns = options.excludedWatchPatterns || [];

    var excludedWatchPatterns = options.excludedWatchPatterns.map(function (r) {
        return new RegExp(r);
    });

    return function () {
        var excluded = options.excludedDirectories.map(function (dir) {
            return "!" + dir + "/";
        }).concat(options.excludedFiles.map(function (e) {
            return "!" + e;
        })).concat(options.excludedExtensions.map(function (ext) {
            return "!*." + ext;
        })).concat(options.excludedPatterns.map(function (e) {
            return { exclude: e.exclude, regex: new RegExp(e.regex) };
        }));

        var copiedFiles = [];

        this.watch(options.extensions.concat(excluded), _asyncToGenerator(function* (filePath, ev, matches) {
            if (!excludedWatchPatterns.some(function (regex) {
                return regex.test(filePath);
            })) {
                copiedFiles.push(filePath);
                var newFilePath = _utilsFs2["default"].changeExtension(filePath, options.changeExtensions);
                var outputPath = _path2["default"].join(options.destination, newFilePath);
                yield _utilsFs2["default"].copyFile(filePath, outputPath, { overwrite: false });

                if (verboseMode) {
                    logger(filePath + " -> " + outputPath);
                }
            }
        }), name, options.dependencies || []);

        this.onComplete(_asyncToGenerator(function* () {
            logger("Copied " + copiedFiles.length + " files");
        }));
    };
};

exports["default"] = copyStaticFiles;
module.exports = exports["default"];