"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, "next"); var callThrow = step.bind(null, "throw"); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _utilsFs = require("../../../utils/fs");

var _utilsFs2 = _interopRequireDefault(_utilsFs);

var _utilsLogging = require("../../../utils/logging");

var _optimist = require("optimist");

var _optimist2 = _interopRequireDefault(_optimist);

var argv = _optimist2["default"].argv;

/*
    options: {
        filename: filename,
        destination: string,
        config: config,
        quiet: bool
    }
*/
var writeConfig = function writeConfig(name, options) {
    var verboseMode = argv["verbose-" + name];
    var logger = (0, _utilsLogging.getLogger)(options.quiet, name || "write-config");

    //defaults
    options.filename = options.filename || "config.json";

    return function () {
        this.onStart(_asyncToGenerator(function* () {
            var outputPath = _path2["default"].join(options.destination, options.filename);
            logger("Writing config to " + outputPath);
            yield _utilsFs2["default"].ensureDirExists(outputPath);
            yield _utilsFs2["default"].writeFile(outputPath, JSON.stringify(options.config, null, "\t"));
        }), name);
    };
};

exports["default"] = writeConfig;
module.exports = exports["default"];