"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, "next"); var callThrow = step.bind(null, "throw"); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _utilsLogging = require("../utils/logging");

var _utilsFora = require("../utils/fora");

var _utilsFora2 = _interopRequireDefault(_utilsFora);

var help = _asyncToGenerator(function* () {
    var version = yield _utilsFora2["default"].getVersion();
    (0, _utilsLogging.print)("\n        fora " + version + " -- A full-stack isomorphic framework for Node.JS and Browser\n\n        Usage:\n            fora <command> <params> <options>\n\n        Commands:\n            build: Build a site\n                fora build [<build-type>] [-s <source>] [-d <destination>]\n\n                eg: fora build\n                eg: fora build production\n                eg: fora build -s ~/code/my-blog -d ~/some/destination/dir\n\n                params:\n                    build-type (optional)\n                        Specify a build type. Defaults to \"debug\" or what's in config.json.\n                        Built-in build types are production, debug and dev.\n\n                options:\n                    --source <source> (or -s <source>)\n                        defaults to current directory\n\n                    --destination <destination> (or -d <destination>)\n                        defaults to <source>/_site\n\n\n            install: Installs a new template from npm or git\n                fora install <template_name> [--git]\n\n                eg: fora install fora-template-blog\n                eg: fora install http://www.github.com/onefora/fora-template-something --git\n\n                params:\n                    template_name\n                        template_name should be a package in npm\n                        But when used with the --git parameter, template_name should be a git location.\n\n                options:\n                    --git clones from git. template_name must be a git url.\n\n\n            new: Create a new site\n                fora new <template> <project_name> [-d <destination>] [--recreate]\n\n                eg: fora new blog my-blog --recreate\n                eg: fora new blog my-blog -d ~/code/fora_apps/\n\n                params:\n                    template\n                        One of the installed fora templates. Use the install command to install a template.\n                        If the template name is fora-template-blog, you may omit the 'fora-template' prefix and just use 'blog'\n\n                options:\n                    --destination <destination> (or -d <destination>)\n                        defaults to <source>/_site\n\n                    --recreate\n                        Deletes the directory if it exists\n\n            version: Display the version number\n                fora version\n                fora -v\n                fora --version\n\n            help: Show this screen\n                fora help\n                fora -h\n                fora --help\n\n    ");
});

exports["default"] = help;
module.exports = exports["default"];