"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, "next"); var callThrow = step.bind(null, "throw"); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _fs = require("./fs");

var _fs2 = _interopRequireDefault(_fs);

var _jsYaml = require("js-yaml");

var _jsYaml2 = _interopRequireDefault(_jsYaml);

var _frontMatter = require("front-matter");

var _frontMatter2 = _interopRequireDefault(_frontMatter);

var reader = {
    json: JSON.parse,
    yaml: _jsYaml2["default"].safeLoad,
    markdown: function markdown(contents) {
        var doc = (0, _frontMatter2["default"])(contents);
        var result = {};
        for (var key in doc.attributes) {
            result[key] = doc.attributes[key];
        }
        result.content = doc.body;
        return result;
    },
    text: function text(a) {
        return a;
    }
};

var knownFormats = {
    json: ["json"],
    yaml: ["yml", "yaml"],
    markdown: ["markdown", "mkdown", "mkdn", "mkd", "md"],
    text: ["txt"]
};

exports["default"] = _asyncToGenerator(function* (fileName, _formats) {
    var formats = Object.assign({}, knownFormats);

    if (_formats) {
        for (var key in _formats) {
            formats[key] = _formats[key];
        }
    }

    for (var key in formats) {
        var regexen = formats[key].map(function (f) {
            return new RegExp("." + f + "$");
        });
        if (regexen.some(function (regex) {
            return regex.test(fileName);
        })) {
            return reader[key]((yield _fs2["default"].readFile(fileName)));
        }
    }

    throw new Error("Unknown file format. Cannot parse " + fileName + ".");
});
module.exports = exports["default"];