/*
    IMPORTANT! No ES6 allowed.
    This file is used by the build bootstrap.
*/

"use strict";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { var callNext = step.bind(null, "next"); var callThrow = step.bind(null, "throw"); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(callNext, callThrow); } } callNext(); }); }; }

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _nodefuncPromisify = require("nodefunc-promisify");

var _nodefuncPromisify2 = _interopRequireDefault(_nodefuncPromisify);

var _extfs = require('extfs');

var _extfs2 = _interopRequireDefault(_extfs);

var _mkdirp2 = require("mkdirp");

var _mkdirp3 = _interopRequireDefault(_mkdirp2);

var _wrench = require("wrench");

var _wrench2 = _interopRequireDefault(_wrench);

var _rimraf = require("rimraf");

var _rimraf2 = _interopRequireDefault(_rimraf);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var mkdirp = (0, _nodefuncPromisify2["default"])(_mkdirp3["default"]);

var exists = (0, _nodefuncPromisify2["default"])(function (what, cb) {
    _fs2["default"].exists(what, function (exists) {
        cb(null, exists);
    });
});

var ensureDirExists = _asyncToGenerator(function* (outputPath) {
    var outputDir = _path2["default"].dirname(outputPath);
    if (!(yield exists(outputDir))) {
        yield mkdirp(outputDir);
    }
});

var empty = (0, _nodefuncPromisify2["default"])(function (path, cb) {
    _extfs2["default"].isEmpty(path, function (result) {
        cb(null, result);
    });
});

var readFile = _asyncToGenerator(function* () {
    var fn = (0, _nodefuncPromisify2["default"])(_fs2["default"].readFile);
    return (yield fn.apply(null, arguments)).toString();
});

var _doCopy = (0, _nodefuncPromisify2["default"])(function (source, target, cb) {
    var cbCalled = false;

    var rd = _fs2["default"].createReadStream(source);
    rd.on("error", function (err) {
        done(err);
    });
    var wr = _fs2["default"].createWriteStream(target);
    wr.on("error", function (err) {
        done(err);
    });
    wr.on("close", function (ex) {
        done();
    });
    rd.pipe(wr);

    function done(err) {
        if (!cbCalled) {
            cb(err);
            cbCalled = true;
        }
    }
});

var copyFile = _asyncToGenerator(function* (source, target, options) {
    options = options || {};
    if (typeof options.overwrite === "undefined" || options.overwrite === null) options.overwrite = true;
    if (typeof options.createDir === "undefined" || options.createDir === null) options.createDir = true;

    var outputDir = _path2["default"].dirname(target);

    if (options.createDir && !(yield exists(outputDir))) {
        yield mkdirp(outputDir);
    }

    if (!options.overwrite && (yield exists(target))) {
        return;
    }

    return yield _doCopy(source, target);
});

/*
    Changes the extension to toExtension
    If fromExtensions[array] is not empty, filePath is changed only if extension is in fromExtensions
*/
var changeExtension = function changeExtension(filePath, extensions) {
    var dir = _path2["default"].dirname(filePath);
    var fileExtension = _path2["default"].extname(filePath);
    var filename = _path2["default"].basename(filePath, fileExtension);
    for (var i = 0; i < extensions.length; i++) {
        var extension = extensions[i];
        if (extension.from && extension.from.length) {
            if (extension.from.indexOf(fileExtension.split(".")[1]) !== -1) return _path2["default"].join(dir, filename + "." + extension.to);
        } else {
            return _path2["default"].join(dir, filename + "." + extension.to);
        }
    }
    return filePath;
};

module.exports = {
    readFile: readFile,
    writeFile: (0, _nodefuncPromisify2["default"])(_fs2["default"].writeFile),
    copyFile: copyFile,
    mkdirp: mkdirp,
    ensureDirExists: ensureDirExists,
    copyRecursive: (0, _nodefuncPromisify2["default"])(_wrench2["default"].copyDirRecursive),
    exists: exists,
    empty: empty,
    changeExtension: changeExtension,
    remove: (0, _nodefuncPromisify2["default"])(_rimraf2["default"]),
    readdir: (0, _nodefuncPromisify2["default"])(_fs2["default"].readdir)
};