"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var print = function print(what, prefix) {
    if (what || prefix) {
        var _log = function _log(x) {
            console.log(prefix ? "[" + prefix + "] " + x : x);
        };

        if (what instanceof Error) {
            _log(what);
            _log(what.stack);
            if (what._inner) {
                _log(what._inner);
                _log(what._inner.stack);
            }
        } else {
            _log(what);
        }
    }
};

var getLogger = function getLogger(quiet, prefix) {
    return function (what) {
        if (!quiet) {
            print(what, prefix);
        }
    };
};

exports.print = print;
exports.getLogger = getLogger;